#include <gpg-error.h>

#include <gpgme++/context.h>
#include <gpgme++/key.h>
#include <gpgme++/keylistresult.h>

#include <vector>
#include <iostream>

int main(int argc, char** argv) {
	GpgME::Context* ctx;
	GpgME::initializeLibrary();

    ctx = GpgME::Context::createForProtocol(GpgME::OpenPGP);
	if(!ctx) {
		std::cout << "failed to get context for OpenPGP" << std::endl;
		return 1;
	}
	
	std::cout << "starting to list keys" << std::endl;
	ctx->startKeyListing("", false);
    GpgME::Error error;

    for (;;) {
      GpgME::Key key;
      key = ctx->nextKey(error);
	  std::cout << "getting next key" << std::endl;
      if (error.encodedError() != GPG_ERR_NO_ERROR) {
        break;
	  }

      bool needPushBack = true;

      std::vector<GpgME::UserID> userIDs = key.userIDs();
      std::vector<GpgME::Subkey> subkeys = key.subkeys();
      for (unsigned int i = 0; i < userIDs.size(); ++i) {
		std::cout << "key #" << i << " " << key.shortKeyID() << " " << userIDs[i].id() << std::endl;
        /*if (subkeys.size() > 0) {
          for (unsigned int j = 0; j < subkeys.size(); ++j) {
            const GpgME::Subkey& skey = subkeys[j];

            if (((skey.canEncrypt() && !secretKeys) || (skey.isSecret() && secretKeys))

                &&  !(skey.isRevoked() || skey.isExpired() || skey.isInvalid()  || skey.isDisabled())) {
              QString entry = QString("%1:%2").arg(key.shortKeyID()).arg(userIDs[i].id());
              list += entry;
              if (needPushBack) {
                d->m_keys.push_back(key);
                needPushBack = false;
              }
            } else {
              // qDebug("Skip key '%s'", key.shortKeyID());
            }
          }
        } else {
          // we have no subkey, so we operate on the main key
          if (((key.canEncrypt() && !secretKeys) || (key.hasSecret() && secretKeys))
              && !(key.isRevoked() || key.isExpired() || key.isInvalid()  || key.isDisabled())) {
            QString entry = QString("%1:%2").arg(key.shortKeyID()).arg(userIDs[i].id());
            list += entry;
            if (needPushBack) {
              d->m_keys.push_back(key);
              needPushBack = false;
            }
          } else {
            // qDebug("Skip key '%s'", key.shortKeyID());
          }
        }
      */}
    }
	
	std::cout << "ending key listing" << std::endl;
    ctx->endKeyListing();
	return 0;
}
